import 'package:flutter/foundation.dart';

const int kEventLogLevel = LOG_TYPE_INFO;

const int LOG_TYPE_ERROR = 0;
const int LOG_TYPE_DEBUG = 1;
const int LOG_TYPE_INFO = 2;

///
const String _ANSI_Black = ' \u001b[30m';
const String _ANSI_Red = '\u001b[31m';
const String _ANSI_Green = '\u001b[32m';
const String _ANSI_Yellow = '\u001b[33m';
const String _ANSI_Blue = '\u001b[34m';
const String _ANSI_Magenta = '\u001b[35m';
const String _ANSI_Cyan = '\u001b[36m';
const String _ANSI_White = '\u001b[37m';
const String _ANSI_Reset = '\u001b[0m';

/// static method to print debug logs of eventizer Package
/// format is simple time, type of [d] or [d] if it is strign, message [msg]
eventLog(int logLevel, dynamic d, String msg) {
  if (kDebugMode) {
    if (logLevel <= kEventLogLevel) {
      switch (logLevel) {
        case LOG_TYPE_ERROR:
          print(
              '$_ANSI_Green ${DateTime.now()}: ${d.runtimeType == String ? d : d.runtimeType}:\t$_ANSI_Red$msg$_ANSI_Reset');
          break;
        case LOG_TYPE_DEBUG:
          print(
              '$_ANSI_Green ${DateTime.now()}: ${d.runtimeType == String ? d : d.runtimeType}:\t$_ANSI_Yellow$msg$_ANSI_Reset');
          break;
        case LOG_TYPE_INFO:
          print(
              '$_ANSI_Green ${DateTime.now()}: ${d.runtimeType == String ? d : d.runtimeType}:\t$_ANSI_White$msg$_ANSI_Reset');
          break;
      }
    }
  }
}
